/*  


ͻ
 Programa  TABELAP   Autor Manoel Carlos Junior Data 31/07/2014   
͹
Descricao  Imprime Tabela de preo.                                   
                                                                      
͹
Modulo    | SIGAFAT  | USO | Especifico do SIGAFAT                     
ͼ


*/


#Include "PROTHEUS.CH"
#Include "REPORT.CH"

User Function TABELAP()

Local oReport
Local oSection1
Local oSection2
Local oBreak
Local cPerg := "TABELAP"


CriaSX1(cPerg)
Pergunte(cPerg, .F.)



DEFINE REPORT oReport NAME "TABELAP" TITLE "Tabela de Preos" PARAMETER cPerg ACTION {|oReport| PrintReport(oReport, cPerg)}

DEFINE SECTION oSection1 OF oReport TITLE "Cabealho" TABLES "DA0"

TRCell():New(oSection1,"DA0_CODTAB","DA0","Cdigo",,,,,,,,,,,,,,,.F.)
DEFINE CELL NAME "DA0_DESCRI"  OF oSection1 ALIAS "DA0"
TRCell():New(oSection1,"DA0_DATDE","DA0","Data",,,,,,,,,,,,,,,.F.)
TRCell():New(oSection1,"DA0_ATIVO","DA0","Ativa",,,,,,,,,,,,,,,.F.)
DEFINE CELL NAME "DA0_XCLI"    OF oSection1 ALIAS "DA0"
TRCell():New(oSection1,"DA0_XLOJA","DA0","Lj",,,,,,,,,,,,,,,.F.)
DEFINE CELL NAME "A1_NREDUZ"   OF oSection1 ALIAS "SA1"
DEFINE CELL NAME "A1_XCODEX"   OF oSection1 ALIAS "SA1"
DEFINE CELL NAME "A1_MUN"      OF oSection1 ALIAS "SA1"
TRCell():New(oSection1,"A1_EST","SA1","Est",,,,,,,,,,,,,,,.F.)
TRCell():New(oSection1,"A1_VEND","SA1","Vend",,,,,,,,,,,,,,,.F.)
TRCell():New(oSection1,"A3_NREDUZ","SA3","Nome",,,,,,,,,,,,,,,.F.)


DEFINE SECTION oSection2 OF oSection1 TITLE "tens" TABLE "DA1"

DEFINE CELL NAME "DA1_ITEM"      OF oSection2 ALIAS "DA1"
DEFINE CELL NAME "DA1_CODPRO"    OF oSection2 ALIAS "DA1"
DEFINE CELL NAME "B1_DESC"       OF oSection2 ALIAS "SB1"
DEFINE CELL NAME "B1_XCODEX"     OF oSection2 ALIAS "SB1"
DEFINE CELL NAME "DA1_PRCVEN"    OF oSection2 ALIAS "DA1"


oReport:SetLandScape(.F.)

oReport :PrintDialog()


Return Nil

//----------------------------------------------------------------------------------------------------------------//


Static Function PrintReport(oReport, cPerg)

#IFDEF TOP
	
	Local cAlias := GetNextAlias()
	Local cSQL := ""
	
	MakeSqlExp(cPerg)
	
	If !Empty(mv_Par01)
		cSQL += "AND DA0_CODTAB >= '" + mv_Par01 + "' "
	EndIf
	If !Empty(mv_Par02)
		cSQL += "AND DA0_CODTAB <= '" + mv_Par02 + "' "
	EndIf
	
	If !Empty(mv_Par05)
		cSQL += "AND DC_PRODUTO >= '" + mv_Par05 + "' "
	EndIf
	If !Empty(mv_Par06)
		cSQL += "AND DC_PRODUTO <= '" + mv_Par06 + "' "
	EndIf
	
	If !Empty(mv_Par07)
		cSQL += "AND DA0_DATDE = '" + DtoS(mv_Par07) + "' "
	EndIf
	
	cSQL := "%"+cSQL+"%"
	
	BEGIN REPORT QUERY oReport:Section(1)
	
	BeginSQL Alias cAlias


        
SELECT 	DA0_CODTAB, DA0_DESCRI, DA0_DATDE, DA0_ATIVO, DA0_XCLI, DA0_XLOJA, A1_NREDUZ,
			A1_XCODEX, A1_MUN, A1_EST, A1_VEND, A3_NREDUZ,
			DA1_ITEM,DA1_CODPRO, B1_DESC, B1_XCODEX, DA1_PRCVEN
FROM %Table:DA0% DA0,  %Table:DA1% DA1, %Table:SB1% SB1, %Table:SA1% SA1 
                  
         LEFT JOIN  %Table:SA3% SA3 ON SA3.A3_COD = SA1.A1_VEND AND
                                 SA3.A3_FILIAL = SA1.A1_FILIAL AND
                                 SA3.%NotDel%
                                         
                   
         WHERE DA0_FILIAL = %xFilial:DA0%  AND DA0.%NotDel% AND
               A1_FILIAL  = %xFilial:SA1%  AND SA1.%NotDel% AND
               DA1_FILIAL = %xFilial:DA1% AND DA1.%NotDel% AND
               B1_FILIAL  = %xFilial:SB1%  AND SB1.%NotDel% AND               
               DA0.DA0_FILIAL = DA1.DA1_FILIAL AND
               DA0.DA0_CODTAB = DA1.DA1_CODTAB AND
               DA0.DA0_FILIAL = SA1.A1_FILIAL  AND
               DA0.DA0_XCLI   = SA1.A1_COD     AND
               DA0.DA0_XLOJA  = SA1.A1_LOJA    AND
               DA1.DA1_FILIAL = SB1.B1_FILIAL  AND
               DA1.DA1_CODPRO = SB1.B1_COD     
               
               
               %Exp:cSQL%       
               
ORDER BY DA0_CODTAB, DA1_ITEM 

EndSQL

END REPORT QUERY oReport:Section(1)   

   

   oReport:Section(1):Section(1):SetParentQuery()
   oReport:Section(1):Section(1):SetParentFilter({|cNum| (cAlias)->DA0_CODTAB == cNum}, {|| (cAlias)->DA0_CODTAB})

   
                           
   oReport:Section(1):Print()
    
#ELSE

   MakeAdvplExpr(cPerg)
	
   dbSelectArea("SZ1")
   dbSetOrder(1)
	
   If !Empty(mv_Par01)
      oReport:Section(1):SetFilter(mv_Par01)               // mv_Par01 contm a range de Contas.
   EndIf

   oReport:Section(1):Section(1):SetParentFilter({|cCodigo| SZ2->Z2_CODCOR == cCodigo}, {|| SZ1->Z1_CODIGO})
   oReport:Section(1):Section(1):SetLineCondition({|| SZ2->Z2_Data >= mv_Par02 .And. SZ2->Z2_Data <= mv_Par03 .And. Z2_Tipo $ IIf(mv_Par04==1,"12",If(mv_Par04==2,"1","2"))})
   
   oReport:Section(1):Print()

#ENDIF

Return Nil

//----------------------------------------------------------------------------------------------------------------//
// Parametros que devem ser passados para a funo de criao das perguntas no arquivo SX1.
//----------------------------------------------------------------------------------------------------------------//
//  1o. Parametro -> Nome do grupo
//  2o. Parametro -> Numero da ordem
//  3o. Parametro -> Texto da pergunta em portugues
//  4o. Parametro -> Texto da pergunta em espanhol
//  5o. Parametro -> Texto  da pergunta em ingles
//  6o. Parametro -> Nome da variavel
//  7o. Parametro -> Tipo do dado C=caractere, D=Data, N=Numerico
//  8o. Parametro -> Tamanho do dado
//  9o. Parametro -> Quantidade de casas decimais para o dado
// 10o. Parametro -> Numero da pre-selecao
// 11o. Parametro -> O tipo do dado sera G=get, S=scroll, C=choice, R=Range
// 12o. Parametro -> Sintaxe em advpl, ou funcao para validacao
// 13o. Parametro -> Consistencia com alguma tabela do sistema via <F3>
// 14o. Parametro -> Nome do grupo para SXG
// 15o. Parametro -> Pyme
// 16o. Parametro -> Nome da variavel que ser utilizada no programa
// 17o. Parametro -> Primeira definicao do texto em portugues se caso o tipo do dado for choice, exemplo: SIM ou Nao
// 18o. Parametro -> Primeira definicao do texto em espanhol se caso o tipo do dado for choice, exemplo: Si o No
// 19o. Parametro -> Primeira definicao do texto em ingles se caso o tipo do dado for choice, exemplo: Yes or No
// 20o. Parametro -> Conteudo da ultima resposta informada no parametro se caso o tipo do dados for get
// 21o. Parametro -> Segunda definicao do texto em portugues se caso o tipo do dado for choice, exemplo: SIM ou Nao
// 22o. Parametro -> Segunda definicao do texto em espanhol se caso o tipo do dado for choice, exemplo: Si o No
// 23o. Parametro -> Segunda definicao do texto em ingles se caso o tipo do dado for choice, exemplo: Yes or No
// 24o. Parametro -> Terceira definicao do texto em portugues se caso o tipo do dado for choice, exemplo: SIM ou Nao
// 25o. Parametro -> Terceira definicao do texto em espanhol se caso o tipo do dado for choice, exemplo: Si o No
// 26o. Parametro -> Terceira definicao do texto em ingles se caso o tipo do dado for choice, exemplo: Yes or No
// 27o. Parametro -> Quarta definicao do texto em portugues se caso o tipo do dado for choice, exemplo: SIM ou Nao
// 28o. Parametro -> Quarta definicao do texto em espanhol se caso o tipo do dado for choice, exemplo: Si o No
// 29o. Parametro -> Quarta definicao do texto em ingles se caso o tipo do dado for choice, exemplo: Yes or No
// 30o. Parametro -> Quinta definicao do texto em portugues se caso o tipo do dado for choice, exemplo: SIM ou Nao
// 31o. Parametro -> Quinta definicao do texto em espanhol se caso o tipo do dado for choice, exemplo: Si o No
// 32o. Parametro -> Quinta definicao do texto em ingles se caso o tipo do dado for choice, exemplo: Yes or No
// 33o. Parametro -> Vetor com o texto do help em portugues
// 34o. Parametro -> Vetor com o texto do help em espanhol
// 35o. Parametro -> Vetor com o texto do help em ingles
// 36o. Parametro -> Nome do grupo do help

Static Function CriaSX1(cPerg)                                                                                                           

Local aHelp := {}

//            Texto do help em portugus                , ingls, espanhol
AAdd(aHelp, {{"Informe o Cdigo da Tabela "            }, {""}, {""}})
AAdd(aHelp, {{"Informe o Cdigo da Tabela "            }, {""}, {""}})
        
//	  	  1o  2o     3o           4  5   6o      7  8  9  10 11  12  13   14 15    16      17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32   33           34         35     36 
PutSX1(cPerg,"01","De Tabela"	,"","","mv_ch1","C",06,00,00,"G","","DA0","","","mv_Par01","","","","","","","","","","","","","","","","",aHelp[1,1],aHelp[1,2],aHelp[1,3],"")
PutSX1(cPerg,"02","At Tabela"  ,"","","mv_ch2","C",06,00,00,"G","","DA0","","","mv_Par02","","","","","","","","","","","","","","","","",aHelp[2,1],aHelp[2,2],aHelp[2,3],"")

Return